var _xmlDoc;		// XMLDocument object
var _module;		// Module object
var _dataFolder = "My_Course";

var _heightDiff		= 4;
var _currentSelectedSlideE;
var _clickedSlides	= 0;

var _isKwrdsContainerVisible = false;

window.onresize	= _onWindowResize;

//-------   Main --------------------------------------------------

function _main(_path) {

	try {

		_parseDataFolder(_path);

		_loadXmlFile(_path);
		_parseXmlManifest();
		_createMenuTree();

		_initPage();

		_setSearchBlock();

		_showFirstSlide()

	}
	catch (_e) {
		switch (_e) {
			case "e1" : alert("ERROR: imsmanifest.xml file could not by found!");
			default   : alert("ERROR: unknown error");
		}
	}

	return false;
}

function _getModule() {
	return _module;
}

function _parseDataFolder(_path) {

	var _idx = _path.indexOf("imsmanifest.xml");

	if (_idx != -1) {
		_dataFolder = _path.substring(0,_idx - 1);
	} else throw "e1";
}

// -------  Load XML File -------------------------------------------

function _loadXmlFile(sUri) {
	_xmlDoc = XmlDocument.create();

	_xmlDoc.async = false;
	_xmlDoc.onreadystatechange = _verify;
	_xmlDoc.load(sUri);
	return true;
}


function _verify() {
	if (_xmlDoc.readyState == 4) return true;
		else return false;
}

// -------  Parse XML Data -------------------------------------------

function _parseXmlManifest() {
	var _orgNode = _getFirstElement(_xmlDoc, "organization");

	// load Module
	_loadModule(_orgNode);
	return true;
}

function _loadModule(_node) {

	var _moduleTitleNode = _getFirstElement(_node, "title");
	var _moduleTitle = _getElementText(_moduleTitleNode);
	_lectureItems = _getChildNodesByName(_node, "item");

	_module = new Module(_moduleTitle, _lectureItems);
	return true;
}

function _getElementText(_node) {
	if (!_node.firstChild) return "";
	return _node.firstChild.nodeValue;
}

function _getFirstElement(_node, _name) {
	return _getElements(_node, _name)[0];
}

function _getElements(_node, _name) {
	var _nodeList = _node.getElementsByTagName(_name);
	return _nodeList;
}

function _getChildNodes(_node) {
	return _node.childNodes;
}

function _getChildNodesByName(_node, _name) {

	var _childNodes = new Array();
	var _allChildNodes = _getChildNodes(_node);

	for (var i=0; i<_allChildNodes.length ; i++) {
		if (_allChildNodes[i].nodeName == _name) {
			_childNodes[_childNodes.length] = _allChildNodes[i];
		}
	}

	return _childNodes;
}

function _getAttribute(_node, _attrName) {

	return _node.getAttribute(_attrName)
}

function _getElementByAttrValue(_node, _nodeName, _attrName, _attrValue) {
	var _elements = _getElements(_node, _nodeName);

	for (var i=0; i<_elements.length; i++ ) {
		var _e = _elements[i];

		if (_getAttribute(_e, _attrName) == _attrValue) {
			return _e;
		}

	}
	return false;
}

function _readHref(_idRef) {
	
	var element = _getElementByAttrValue(_xmlDoc, "resource", "identifier", _idRef);
	if (element) {
		return _getAttribute(element, "href");
	}

	return "";
	
}

function _getKeywords(_slideItem) {
	
	var _kwrds = new Array();

	var _metadata = _getFirstElement(_slideItem, "metadata");
	if (!_metadata) return _kwrds;

	var _lom = _getFirstElement(_metadata, "lom");
	if (!_lom) return _kwrds;

	var _general = _getFirstElement(_lom, "general");
	if (!_general) return _kwrds;

	var _kwrdsElements = _getElements(_general, "keyword");
	if (_kwrdsElements.length == 0) return _kwrds;

	for (var i=0; i<_kwrdsElements.length ; i++) {
		var _kwLangE = _getFirstElement(_kwrdsElements[i], "langstring");

		var _kwrd = _getElementText(_kwLangE);

		_kwrds[_kwrds.length] = _kwrd
	}

	return _kwrds;
	
}



//----- Create Menu Tree -----------------------------------------------------

function _createMenuTree() {
	var _mtE = _getMenuTreeElement();

	var _lectures = _module.getLectures();
	for (var i=0; i<_lectures.length ; i++ ) {
		_createLectureElement(_mtE, _lectures[i], i);		
	}
	return true;
}

function _createLectureElement(_parentE, _lecture, _order) {

	var _lctId = _lecture.getId();
	var _lctTitle = _lecture.getTitle();

	var _icon = "uLern_Viewer/img/folder.gif"

	if (_lctId == "I_info")  _icon = "uLern_Viewer/img/folder_icon.gif"
	
	var _title = (_order == 0) ? "Info" : (_order) + ". " + _phrLecture;

	var _imgHtmlCode = "<a title=\"" + _title + "\" href=\"javascript:_toggle('" + _lctId + "');\"><img id=\"x_" + _lctId + "\" src='" + _icon + "' width='16' height='16' hspace='0' vspace='0' border='0'></a>";
	var _captionHtmlCode = "<div class='lectItem'" + _getEventString() + "><a class='item' href=\"javascript:_toggle('" + _lctId + "');\">" + _lctTitle + "</a></div>";

	var _lectE = _createTableElement(_parentE, _imgHtmlCode, _captionHtmlCode);

	
	// slides
	var _slidesE = document.createElement("div");
	_slidesE.setAttribute("id", _lctId);
	_slidesE.style.cssText = "display: none; margin-left: 1em;";
	_parentE.appendChild(_slidesE);

	var _slides = _lecture.getSlides();

	for (var i=0; i<_slides.length ; i++) {
		var _slide = _slides[i];
		_createSlideElement(_slidesE, _slide, i);
	}
	return true;
}

function _createSlideElement(_parentE, _slide, _order) {

	var _sldId = _slide.getId();
	var _sldTitle = _slide.getTitle();
	var _sldHref;

	if (_slide.getHref() != "") {
		_sldHref = _dataFolder + "/" + _slide.getHref();
	} else {
		_sldHref = "uLern_Viewer/html/blank.htm";
	}




	var _icon = "uLern_Viewer/img/item";
	if (_slide.getVideo()) _icon += "V";
	if (_slide.getAudio()) _icon += "A";
	if (_slide.getAssess()) _icon += "_a";
	if (_slide.getTask()) _icon += "_t";

	_icon += ".gif";

	var _title =(_order + 1) + ". " + _phrSlide;

	if (_slide.getTask() || _slide.getAssess() || _slide.getAudio() || _slide.getVideo()) {
		_title += ", " + _phrBeginTitle + " ";

		var _notFirst = false;

		if (_slide.getTask()) {
			_title += _phrTask;
			_notFirst = true;
		}
		
		if (_slide.getAssess()) {
			if (_notFirst) _title += ", " + _phrAssess;
				else _title += _phrAssess;
			_notFirst = true;
		}

		if (_slide.getAudio()) {
			if (_notFirst) _title += ", " + _phrAudio;
				else _title += _phrAudio;
		}

		if (_slide.getVideo()) {
			if (_notFirst) _title += ", " + _phrVideo;
				else _title += _phrVideo;
		}

		_title += " " + _phrEndTitle;

	}


	var _imgHtmlCode = "<a title=\"" + _title + "\" _order=\"" + _order + "\" _clicked='0' href=\"" + _sldHref + "\" target=\"_previewFrame\" onClick=\"_selectSlide(document.getElementById('"  + _sldId + "'));return false;\"><img id=\"icon_" + _sldId + "\" src='" + _icon + "' width='24' height='16' hspace='0' vspace='0' border='0'></a>";
	var _captionHtmlCode = "<a class='item' id=\"" + _sldId + "\" _order=\"" + _order + "\" _clicked='0' href=\"" + _sldHref + "\" target=\"_previewFrame\" onClick=\"_selectSlide(this);return false;\">" + _sldTitle + "</a>";
//	var _captionHtmlCode = "<div " + _getEventString() + "><a id=\"" + _sldId + "\" href=\"" + _sldHref + "\" target=\"_blank\">" + _sldTitle + "</a></div>";

	_createTableElement(_parentE, _imgHtmlCode, _captionHtmlCode);	
	return true;
}

function _getEventString() {
	return "onMouseover='_mouseOver(this);return false;' onMouseout='_mouseOut(this);return false;'"
}


function _getMenuTreeElement() {

	var _mte = document.getElementById("_bottomPart");
	_removeChilds(_mte);
	return _mte;
}

function _removeChilds(_element) {
	
	while(_element.childNodes.length) {
		var _child = _element.childNodes[0];
		_removeElement(_element, _child);		
	}

}

function _removeElement(_parent, _element) {

	while(_element.childNodes.length) {
		var _child = _element.childNodes[0];	
		_removeElement(_element, _child);		
	}

	_parent.removeChild(_element);
}

function _createTableElement(_parentE, _imgHtmlCode, _captionHtmlCode) {
	//_parentE.innerHTML="<img src='img/folder.gif' width='16' height='16' hspace='0' vspace='0' border='0'>";

	// <table>

	_tableE = document.createElement("table");
	_tableE.setAttribute("border","0");
	_tableE.setAttribute("cellpadding","1");
	_tableE.setAttribute("cellspacing","1");
	_parentE.appendChild(_tableE);

	_tbodyE = document.createElement("tbody");
	_tableE.appendChild(_tbodyE);

	// <tr>

	_trE = document.createElement("tr");
	_tbodyE.appendChild(_trE);

	// <td> 1

	_tdE1 = document.createElement("td");
	_trE.appendChild(_tdE1);

	_tdE1.innerHTML = _imgHtmlCode;

	// <td> 2

	_tdE2 = document.createElement("td");
	_trE.appendChild(_tdE2);

	_tdE2.innerHTML = _captionHtmlCode;

//	alert(_dump(_tdE2));
	return true;
}



function _dump(_obj) {

	var _msg	= '';

	for (var _i in _obj) {
		if(_obj[_i])	_msg += _i + " = " + _obj[_i] + "\n";
	}
	return _msg;
} 


// ------   Preview functioons ----------------------------------------------------------------


function _getDocumentHeight() {

	if (is_ie5 || is_ie5_5) {
		docHeight = document.body.clientHeight;
	} else if (is_ie6) {
		docHeight = document.documentElement.clientHeight;
	} else if (is_moz) {
		docHeight = window.innerHeight;
	} else if (is_nav) {
		docHeight = window.innerHeight;
	}

	return docHeight;
}


function _fixHeights() {

//	document.getElementById("_previewTable").height=document.body.offsetHeight-document.getElementById("_previewTable").offsetTop-26;


//	var _docHeightTotal = _getDocumentHeight();
//	var _docHeight = _docHeightTotal - 30;   // full screen - top bar
	var _docHeight = _getDocumentHeight() - 6;


	var _uppH = document.getElementById("_upperPart").scrollHeight;
	var _statH = document.getElementById("_statusPart").scrollHeight;
	var _totalTmpH	= _uppH + _statH ;


	document.getElementById("_previewTable").style.height	= _docHeight  + "px";

	var _bottomPartHeight = _docHeight - _totalTmpH - 2*_heightDiff;
	if (_bottomPartHeight < 0) return;

	document.getElementById("_bottomPart").style.height		= _bottomPartHeight + "px"
	document.getElementById("_previewFrame").style.height	= _docHeight  + "px";

	return true;
}


function _onWindowResize() {

	_fixHeights();
	return true;
}


function _initPage() {

	_initMediaPlayer();
	_fixHeights();
	return true;
}


// -------  SLIDE CLICK ----------------------------------------------------------


function _selectSlide(_slideE) {
	
	if (_currentSelectedSlideE) {
		if (_currentSelectedSlideE.className == "kwrdItemSelected") {
			_currentSelectedSlideE.className = "kwrdItem";
		} else {
			_currentSelectedSlideE.className = "item";
		}
	}
	
	if (_slideE.className == "kwrdItem") {
		_slideE.className = "kwrdItemSelected";
	} else {
		_slideE.className = "itemSelected";
	}

	_setClickedIcon(_slideE);
	
	var _slide = _module.getSlideById(_slideE.id);

	_showPreviewIcons(_slide);

	document.getElementById("_previewFrame").src = _slideE.href;

	// set keywords block
	_setKeywordsBlock(_slide);
	_selectKwrdsInSearchBlock(_slide);

	_setMediaPlayer(_slide);
	

	_currentSelectedSlideE = _slideE;

	_fixSlideClick(_slideE);
	_refreshProgress();

	return false;
}

function _setMediaPlayer(_slide) {
	// play audio
	if (_slide.getAudio()) {
		_playMedia(_dataFolder + "/" + _slide.getAudio());
	} else 	{
			// play video
			if (_slide.getVideo()) {
				_playMedia(_dataFolder + "/" + _slide.getVideo());
			} else {
				// Stop player
				_playMedia("");
			}
	}
}

function _setClickedIcon(_slideE) {
	var _clicked = _slideE.getAttribute("_clicked");

	if (_clicked == 1) return;
	

	var _sldId = _slideE.getAttribute("id");
	var _sldIconE = document.getElementById("icon_" + _sldId);

	var _iconSrc = _sldIconE.getAttribute("src");

	_iconSrc = _iconSrc.replace("item", "d_item");

	_sldIconE.setAttribute("src", _iconSrc);
}


function _showPreviewIcons(_slide) {
	

	// TASK
	if (_slide.getTask()) {
		document.getElementById("_taskIconImg").src = 'uLern_Viewer/img/task_1.gif';
		document.getElementById("_taskIconImg").setAttribute("_enabled", "1");
		_setHrefEnabled(document.getElementById("_taskIcon"), _dataFolder + "/" + _slide.getTask(), true, true);
	} else {
		document.getElementById("_taskIconImg").src = 'uLern_Viewer/img/task_0.gif';
		document.getElementById("_taskIconImg").setAttribute("_enabled", "0");
		_setHrefEnabled(document.getElementById("_taskIcon"), "", false, true);
	}

	// ASSESSMENT
	if (_slide.getAssess()) {
		document.getElementById("_assessIconImg").src = 'uLern_Viewer/img/assess_1.gif';
		document.getElementById("_assessIconImg").setAttribute("_enabled", "1");
		_setHrefEnabled(document.getElementById("_assessIcon"), _dataFolder + "/" + _slide.getAssess(), true, true);
	} else {
		document.getElementById("_assessIconImg").src = 'uLern_Viewer/img/assess_0.gif';
		document.getElementById("_assessIconImg").setAttribute("_enabled", "0");
		_setHrefEnabled(document.getElementById("_assessIcon"), "", false, true);
	}

	// KEYWORDS
	if (_slide.hasKeywords()) {
		document.getElementById("_kwrdIconImg").src = 'uLern_Viewer/img/kwrd_1.gif';
		document.getElementById("_kwrdIconImg").setAttribute("_enabled", "1");
		_setHrefEnabled(document.getElementById("_kwrdIcon"), "javascript: _showKwrdsBlock(true, false);", true, false);
	} else {
		document.getElementById("_kwrdIconImg").src = 'uLern_Viewer/img/kwrd_0.gif';
		document.getElementById("_kwrdIconImg").setAttribute("_enabled", "0");
		_setHrefEnabled(document.getElementById("_kwrdIcon"), "", false, false);
	}


	// AUDIO
	if (_slide.getAudio()) {
		document.getElementById("_audioIconImg").src = 'uLern_Viewer/img/audio_1.gif';
		document.getElementById("_audioIconImg").setAttribute("_enabled", "1");
		document.getElementById("_audioIcon").setAttribute("type", _slide.getMimeType());
		_setHrefEnabled(document.getElementById("_audioIcon"), _dataFolder + "/" + _slide.getAudio(), true, false);
	} else {
		document.getElementById("_audioIconImg").src = 'uLern_Viewer/img/audio_0.gif';
		document.getElementById("_audioIconImg").setAttribute("_enabled", "0");
		document.getElementById("_audioIcon").setAttribute("type", "");
		_setHrefEnabled(document.getElementById("_audioIcon"), "", false, false);
	}

	// VIDEO
	if (_slide.getVideo()) {
		document.getElementById("_videoIconImg").src = 'uLern_Viewer/img/video_1.gif';
		document.getElementById("_videoIconImg").setAttribute("_enabled", "1");
		document.getElementById("_videoIcon").setAttribute("type", _slide.getMimeType());
		_setHrefEnabled(document.getElementById("_videoIcon"), _dataFolder + "/" + _slide.getVideo(), true, false);
	} else {
		document.getElementById("_videoIconImg").src = 'uLern_Viewer/img/video_0.gif';
		document.getElementById("_videoIconImg").setAttribute("_enabled", "0");
		document.getElementById("_videoIcon").setAttribute("type", "");
		_setHrefEnabled(document.getElementById("_videoIcon"), "", false, false);
	}

}

var _lastShowedHref = "";

function _setPreviewFrame(_href) {


	if (window.frames["_previewFrame"].location.href.indexOf(_href) != -1) {
		if (_lastShowedHref != "") window.frames["_previewFrame"].location = _lastShowedHref;
		_lastShowedHref = "";
	} else {
		_lastShowedHref = window.frames["_previewFrame"].location.href;
		window.frames["_previewFrame"].location = _href;
	}
}

function _setHrefEnabled(_element, _href, _value, _js) {

	var _cursor = (_value) ? "pointer" : "default";

	if (_href != "") {
		if (_js) { 
			_element.setAttribute("href", "javascript: _setPreviewFrame('" + _href + "');");
		} else {
			_element.setAttribute("href", _href);
		}
	} else {
		_element.removeAttribute("href");
	}
	_element.onclick = new function() {return _value;};
	_element.style.cssText = "cursor:" + _cursor;

}

//------- Slide Navigacia ---------------------------------------------------
function _showSlide(_dir) {

	var _currLect = _module.getLectureBySlideId(_currentSelectedSlideE.id); 
	var _currOrder = parseInt(_currentSelectedSlideE.getAttribute("_order"));

	

	var _newOrder = _currOrder + _dir;
	
	if (_newOrder < 0) {
		_showPrevLect(_currLect);
		return;
	}

	if (_newOrder > (_currLect.getSlidesCount() - 1)) {
		_showNextLect(_currLect);
		return;
	}


	var _newSlide = _currLect.getSlideByOrder(_newOrder);

	_selectSlide(document.getElementById(_newSlide.getId()));
}

function _showLecture(_dir) {

	var _currLect = _module.getLectureBySlideId(_currentSelectedSlideE.id);
	var _currOrder = parseInt(_currentSelectedSlideE.getAttribute("_order"));

	if (_dir == -1) {
	
		if (_currOrder == 0) {
			_showPrevLect(_currLect);
			return;
		}
		_newSlide = _currLect.getFirstSlide();
		_selectSlide(document.getElementById(_newSlide.getId()));
	} else if (_dir == 1) {

		if (_currOrder == (_currLect.getSlidesCount() - 1)) {
			_showNextLect(_currLect);
			return;
		}
		_newSlide = _currLect.getLastSlide();
		_selectSlide(document.getElementById(_newSlide.getId()));
	}
}

function _showPrevLect(_currLect) {
	var _newLectOrder = _currLect.getOrder() - 1;
	if (_newLectOrder < 0) return;
	
	_currLect = _module.getLectureByOrder(_newLectOrder);
	_newSlide = _currLect.getLastSlide();

	_openLecture(_currLect.getId());

	_selectSlide(document.getElementById(_newSlide.getId()));
}

function _showNextLect(_currLect) {
	var _newLectOrder = _currLect.getOrder() + 1;
	if (_newLectOrder > (_module.getLecturesCount() - 1)) return;
	
	_currLect = _module.getLectureByOrder(_newLectOrder);
	_newSlide = _currLect.getFirstSlide();

	_openLecture(_currLect.getId());

	_selectSlide(document.getElementById(_newSlide.getId()));
}

function _openLecture(_lectId) {
	if (document.getElementById(_lectId).style.display == "none") {
		_toggle(_lectId);
	}
}

function _showFirstSlide() {
	
	var _firstLect = _module.getLectureByOrder(0);
	var _firstSlide = _firstLect.getSlideByOrder(0);

	_openLecture(_firstLect.getId());
	_selectSlide(document.getElementById(_firstSlide.getId()));
}

//----- PROGRESS BAR ---------------------------------------------------------
function _refreshProgress() {

//	return;
	
	var _perc	= Math.round(_clickedSlides / _module.getSlideCount() * 100);

	var _pObj	= document.getElementById('_slideProgress');	// Progress
	var _rObj	= document.getElementById('_slideRest');		// Rest

	if(_perc > 100)	_perc = 100;

   	_pObj.style.cssText = "width: " + _perc + "%";
   	if (_perc != 0) _pObj.innerHTML		= "&nbsp";

   	_rObj.style.cssText	= "width: " + (100 - _perc) + "%";
   	_rObj.innerHTML		= "&nbsp";

	var _str	= _clickedSlides + '/' + _module.getSlideCount() + ' (' + _perc + '%)';

	if(_perc == 100)	_rObj.style.cssText = "display: none";

	if(_perc > 50)	_pObj.innerHTML	= _str;
	else		_rObj.innerHTML	= _str;

	return true;
}

function _fixSlideClick(_sObj) {

	if(_sObj.getAttribute("_clicked") == 0) {
		_sObj.setAttribute("_clicked", "1");
		_clickedSlides++;
	} 
}

//--------- MEDIA PLAYER --------------------------------------------------------

var _gtVer6_4		= true;
var _playerObj		= new Object();

function _setMediaFile(_url) {

	if(_gtVer6_4)	_playerObj.URL		= _url;
	else		_playerObj.fileName	= _url;
}

function _initMediaPlayer() {

	if(document.getElementById("_player")) {
	
		_playerObj	= document.getElementById("_player");
		
		if(_playerObj.controls) {
		
			_gtVer6_4	= true;
			
		} else {
		
			_gtVer6_4	= false;
			
			_html		= "<OBJECT ID=\"_player\" width=\"160\" height=\"200\" CLASSID=\"CLSID:22D6f312-B0F6-11D0-94AB-0080C74C7E95\" TYPE=\"application/x-oleobject\"><param name=\"ShowPositionControls\" value=\"false\"></OBJECT>";
			_playerObj.outerHTML	= _html;
			_playerObj	= document.getElementById("_player");
		}

	} else	_playerObj	= false;
}

function _playMedia(_url) {

	if(_playerObj) {

		// show / hide MP

		if (is_ie) {
			var _displ = (_url == "") ? "none" : "block";
			if (_isKwrdsContainerVisible && _displ == "block") return;
			_playerObj.style.cssText = "margin: 3px 0px 3px 1px; display:  " + _displ;
			_fixHeights();
		}

       	_setMediaFile(_url);

       	return true;
   	} else	return false;
}

//--- KEYWORDS object ---------------------------------------------------------------


function _showKwrdsContainer(_value) {

	// stop & hide MP
	_playMedia("");
	
	var _kwrdsContainer	= document.getElementById("_kwrdsContainer");
	if (_kwrdsContainer) {
	
			

			var _displ = (!_value) ? "none" : "block";
			_kwrdsContainer.style.cssText = "display:  " + _displ;

			_showObject("_kwrdsContainer");
			
			if (_value) {
				_showObject("_kwrdsBlock");
				_showObject("_searchBlock");
			} else {
				_hideObject("_kwrdsBlock");
				_hideObject("_searchBlock");
			}

			_fixHeights();
	}


	_isKwrdsContainerVisible = _value;

	if (!_value) {
		_deselectAllSlidesByKwrd();
		_setMediaPlayer(_module.getSlideById(_currentSelectedSlideE.id));
	}

	if (!_value ) {
		_isSearchBlockVisible = false;
		_isKwrdsBlockVisible = false;
	}


}

function _showKwrdsBlock(_kwrdsValue, _searchValue) {

	_showKwrdsContainer(true);
	

	var _kwrdsBlock	= document.getElementById("_kwrdsBlock");
	var _searchBlock = document.getElementById("_searchBlock");

	
	if (_kwrdsBlock) {

			if (_kwrdsValue && _isKwrdsBlockVisible) {
				_showKwrdsContainer(false);
				_isKwrdsBlockVisible = false;

			} else {			

				var _displ = (!_kwrdsValue) ? "none" : "block";
				_kwrdsBlock.style.cssText = "display:  " + _displ;

				(_kwrdsValue) ? _showObject("_kwrdsBlock") : _hideObject("_kwrdsBlock");

				_isKwrdsBlockVisible = _kwrdsValue;
			}
	}

	if (_searchBlock) {

			if (_searchValue && _isSearchBlockVisible) {
				_showKwrdsContainer(false);
				_isSearchBlockVisible = false;

			} else {			

				var _displ = (!_searchValue) ? "none" : "block";
				_searchBlock.style.cssText = "display:  " + _displ;

				(_searchValue) ? _showObject("_searchBlock") : _hideObject("_searchBlock");

				_isSearchBlockVisible = _searchValue;
			}

	}

	_fixHeights();

}

var _isKwrdsBlockVisible = false;
var _isSearchBlockVisible = false;



function _showObject(_id) {
  if (document.getElementById) {
    document.getElementById(_id).style.visibility = 'visible';
  }
  else if (document.layers && document.layers[_id]) {
    document.layers[_id].visibility = 'visible';
  }
  else if (document.all) {
    document.all[_id].style.visibility = 'visible';
  }
}

function _hideObject(_id) {
  if (document.getElementById) {
    document.getElementById(_id).style.visibility = 'hidden';
  }
  else if (document.layers && document.layers[_id]) {
    document.layers[_id].visibility = 'hidden';
  }
  else if (document.all) {
    document.all[object].style.visibility = 'hidden';
  }
}

function _setKeywordsBlock(_slide) {
	var _kwrdsList = document.getElementById("_kwrdsList");

	var _kwrds = _slide.getKeywords();

	_kwrdsList.value = "";

	for (var i=0; i<_kwrds.length ; i++) {
		_kwrdsList.value = _kwrdsList.value + _kwrds[i];
		if (i != (_kwrds.length - 1) )  _kwrdsList.value = _kwrdsList.value + "\n";
	}
}

function _selectKwrdsInSearchBlock(_slide) {

	var _searchList = document.getElementById("_searchList");
	var _kwrds = _slide.getKeywords();

	for (var i=0; i<_searchList.options.length ; i++) {

		var _optionObj = _searchList.options[i];
		if (_contains(_kwrds, _optionObj.value)) {
			_optionObj.style.cssText = "color: #f00;";
		} else {
			_optionObj.style.cssText = "color: #000;";
		}
	}

}

function _setSearchBlock() {

	var _hasKwrds = _module.hasKeywords();

	if (!_hasKwrds) {
		var _searchIconImg = document.getElementById("_searchIconImg");
		_searchIconImg.setAttribute("src", "uLern_Viewer/img/search_0.gif");
		_setHrefEnabled(document.getElementById("_searchIcon"), "", false);
	}



	var _searchList = document.getElementById("_searchList");
	var _kwrds = _module.getAllKeywords();


	for (var i=0; i<_kwrds.length ; i++) {
		var _optionObj = new Option(_kwrds[i], _kwrds[i]);
		_optionObj.style.cssText = "color: #f00;";
		_searchList.options[_searchList.options.length] = _optionObj;
	}

}

function _selectSlidesByKwrd() {
	var _searchList = document.getElementById("_searchList");
	var _kwrd = _searchList.options[_searchList.selectedIndex].value;

	var _slidesIdList = _module.getSlidesIdByKwrd(_kwrd);
	//alert(_slidesIdList);

	var _sObj = document.getElementById('_searchInput');
	if(_sObj) {
		_sObj.value = _kwrd;
	}

	_collapseAllLectures();
	_deselectAllSlidesByKwrd();

	for (var i=0; i<_slidesIdList.length ; i++) {
		
		var _slideId = _slidesIdList[i];

		// expand lecture
		var _lecture = _module.getLectureBySlideId(_slideId);
		_expand(_lecture.getId());

		// change text color

		var _slideE = document.getElementById(_slideId);
		if (_slideE.className == "itemSelected") {
			_slideE.className = "kwrdItemSelected";
		} else {
			_slideE.className = "kwrdItem";	
		}

//		alert(_slideE.outerHTML);

	}
}

function _deselectAllSlidesByKwrd() {
	
	var _lectures = _module.getLectures();
	
	for (var i=0 ; i<_lectures.length ; i++) {
		var _slides = _lectures[i].getSlides();

		for (var j=0; j<_slides.length ; j++) {
			// change text color
			var _slideE = document.getElementById(_slides[j].getId());
			
			if (_slideE.className == "itemSelected") continue;
			
			if (_slideE.className == "kwrdItemSelected") {
				_slideE.className = "itemSelected";
			} else {
				_slideE.className = "item";
			}

			
		}
	}
}

function _collapseAllLectures() {
	
	var _lectures = _module.getLectures();
	
	for (var i=0 ; i<_lectures.length ; i++) {
		_collapse(_lectures[i].getId());
	}
}

function _searchKwrd() {

	var _sObj = document.getElementById('_searchInput');
	if(!_sObj) return;

	var _sKey		= _sObj.value;
	var _sLen		= _sKey.length;
	var _keySubstr;
	var _found		= false;

	var _searchList = document.getElementById("_searchList");

	for (var i=0; i<_searchList.options.length; i++) {
		var _kwrd = _searchList.options[i].value;
		_keySubstr	= _kwrd.substr(0, _sLen);
		if(_keySubstr.toLowerCase() == _sKey.toLowerCase()) {
			_found	= true;
			_searchList.selectedIndex = i;
			_selectSlidesByKwrd();
			break;
		}
	}


	if(!_found)	 {
		alert(_phrNonexistKey);
	}

	_keyFocus();
	event.returnValue = false;
}

function _keyFocus() {

	var _sObj;
	if(_sObj = document.getElementById('_searchInput')) {
//		alert("bavi");
		_sObj.focus();
		_sObj.select();
	}
}

// print ----------------------------------------
function _print() {
//	var _printWin = window.open('uLern_Viewer/html/print.htm','','scrollbars=yes,menubar=yes,height=600,width=800,resizable=yes,toolbar=no,location=no,status=no');

	var _loc = window.frames["_previewFrame"].location;
	var _printWindow = window.open(_loc,'','scrollbars=yes,menubar=yes,height=600,width=800,resizable=yes,toolbar=no,location=no,status=no');
	
	_printWindow.print();

//	_printWindow.close();
}

function _closeMe(_win) {
	_win.close();
}

